> For the complete documentation index, see [llms.txt](https://docs.clipper.exchange/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.clipper.exchange/disclaimers-and-technical/integrating-with-clipper-rfq/guides/integration-examples/swap-shorttail-native-token.md).

# Swap Shorttail → Native token

E.g: OP → 0.01 ETH on Optimism (Chain 10)

{% file src="/files/II7qG5dv1PQnCMROInAV" %}
ABI used in the example
{% endfile %}

{% hint style="info" %}
Since this is a L2 (optimism) example, we use <mark style="color:orange;">`packed`</mark> form values, as explained [here](/disclaimers-and-technical/integrating-with-clipper-rfq/guides/interacting-with-the-clipper-exchange-contracts.md#packed-format-values). In this case, we need to call the <mark style="color:orange;">`packedTransmitAndSwap`</mark> method from clipper’s smart contract which has the following interface:

<mark style="color:orange;">`function packedTransmitAndSwap(uint256 packedInput, uint256 packedOutput, uint256 packedGoodUntil, bytes32 auxData, bytes32 r, bytes32 vs)`</mark>
{% endhint %}

```javascript
const fetch = require('node-fetch');
import ethers from "ethers";
import packedExchangeAbi from "./packedExchangeAbi.json";
import { hexZeroPad } from 'ethers/lib/utils';

// Get a quote
async function getQuote() {
  const quotePayload = {
    "pool_address": "0x663fA8731045765067e2B5b6acB19BE2ce974C7f",
    "output_asset_symbol": "ETH",
    "input_asset_symbol": "OP",
    "time_in_seconds": 60,
    "output_amount": "10000000000000000"
  };
  const queryString = new URLSearchParams(quotePayload).toString();
  const requestOptions = {
    method: 'GET',
    headers: {
      'x-api-key': 'YXBpLXVzZXI6dXNlci1wYXNz',  // This is a placeholderer,
      'Content-Type': 'application/json'
    }
  };

  const response = await fetch(`https://blade-api.sushi.com/rfq/v2/quote/10?${queryString}`);
  const quote = await response.json();
  
  return quote;
}

// Sign the quote
async function signQuote(quoteId) {
  const signPayload = {
    "quote_id": quoteId,
    "destination_address": "0xab83Af831dfb4028EBFd3fFA74A828a4d5DCaAC5"
  };

  const requestOptions = {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(signPayload)
  };

  const response = await fetch('https://blade-api.sushi.com/rfq/sign', requestOptions);
  const signResponse = await response.json();
  
  return signResponse;
}

// Execute transaction
async function executeSwap(signResponse) {
  const provider = new ethers.providers.JsonRpcProvider(process.env.RPC_URL);
  const clipperPackedContract = new ethers.Contract(
    signResponse.clipper_exchange_address,
    packedExchangeAbi,
    provider
  );

  const auxData = "0x00000000000000000000000000000000000000000000000000";
  const packedInput = packAddressAndAmount(signResponse.input_amount, signResponse.input_asset_address);
  const packedOutput = packAddressAndAmount(signResponse.output_amount, signResponse.output_asset_address);
  const packedGoodUntil = signResponse.good_until;
  const packedData = packAddressAndAmount(auxData, signResponse.destination_address);
  const r = byte32(signResponse.signature.r);
  const vs = byte32(shortenSignature(signResponse.signature.s, signResponse.signature.v));

  const result = await clipperPackedContract.packedTransmitAndSwap(
    packedInput, packedOutput, packedGoodUntil, auxData, r, vs
  );
}

// In order to calculate the packed values, we can use the following methods
function packAddressAndAmount(amount, address) {
  const addressBn = BigInt(address);
  const amountBn = BigInt(amount);

  return (amountBn << 160n) + addressBn;
}

// Converts the value to 32 bytes and fills the rest with leading zeroes.
function byte32(value) {
  return hexZeroPad(value.toString(16), 32);
}

function shortenSignature(s, v) {
  const parity = BigInt(v - 27);
  const shiftedParity = parity << 255n;

  return s + shiftedParity.toString(16);
}

// Main function
async function main() {
  // 1. Get a quotey
  const quote = await getQuote();
  console.log("Quote:", quote);
  
  // 2. Sign a quote
  const signResponse = await signQuote(quote.id);
  console.log("Sign Response:", signResponse);
  
  // 3. Execute transaction
  await executeSwap(signResponse);
  console.log("Swap executed successfully.");
}

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.clipper.exchange/disclaimers-and-technical/integrating-with-clipper-rfq/guides/integration-examples/swap-shorttail-native-token.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
